#include <stdio.h>
#include <unistd.h>
#include <malloc.h>
#include <pthread.h>
#include <semaphore.h>
struct queue {
    void *data;
    size_t size;
    struct queue *next;
};
//
struct queue *buff;

//   
pthread_mutex_t buff_mutex=PTHREAD_MUTEX_INITIALIZER;
//  
sem_t buff_count;
//condition variable        - 
pthread_cond_t reader_cv=PTHREAD_COND_INITIALIZER;
//  condition variable
pthread_mutex_t reader_mutex=PTHREAD_MUTEX_INITIALIZER;

//     
//  
void* writer(void *arg){
    struct queue *data,*prev;
    while(1){
        sem_wait(&buff_count);//-    
	pthread_mutex_lock(&buff_mutex);//   
	if(!buff){
	    pthread_mutex_unlock(&buff_mutex);//   
	    break;//
	}
        data=buff;// 
	prev=buff;
        while(data->next){//   
    	    prev=data;
	    data=data->next;
        }
	if(prev==data){//   1 
	    buff=NULL;// 
        }else{
    	    prev->next=NULL;//     
	}
	/* data        */
	pthread_mutex_unlock(&buff_mutex);//   
	/*    */
	write(1,data->data,data->size);
	//fprintf(stderr,"%d bytes writed\n",data->size);
	free(data->data);
	free(data);
	pthread_cond_signal(&reader_cv);
    }
}

#define BUFFSIZE 32	//
#define CLUSTER 1048576 //1

int main(int argc, char *argv[]){
    size_t readed=0;
    struct queue *data;
    pthread_t tid;
    int smv=0,s=0;
    
    
    if(argc<2){
	fprintf(stderr,"Usage : %s <buffer_size> in MB\nLike %s 128\n",argv[0],argv[0]);
	return -1;
    }
    s=atoi(argv[1]);
    if((s<2)||(s>4096)){
	s=BUFFSIZE;
	fprintf(stderr,"Buffer size incorect, using default %dMB\n",BUFFSIZE);
	
    }
    
    buff=NULL;
    sem_init(&buff_count,0,0);

    pthread_create(&tid,NULL,&writer,NULL);
    pthread_mutex_lock(&reader_mutex);
    while(1){
	sem_getvalue(&buff_count,&smv);
	if(smv>=s){//     - ģ   ,    -
		
	    /* pthread_cond_wait  , ģ    
		*/
		pthread_cond_wait(&reader_cv,&reader_mutex);
	};
	    
	data=malloc(sizeof(struct queue));
	if(!data)break;
        data->data=malloc(CLUSTER);
	if(!data->data)break;
	
    
	//readed=read(0,data->data,CLUSTER);//   pipe -    
	readed=fread(data->data,1,CLUSTER,stdin);// ޣ  - ӣ    1   read
        if(!readed)break;// 
	data->size=readed;
	
	pthread_mutex_lock(&buff_mutex);
        data->next=buff;
	buff=data;
        pthread_mutex_unlock(&buff_mutex);
        /*  -  */
	sem_post(&buff_count);
        //fprintf(stderr,"queue size=%d, %d bytes readed\n",smv,readed);
	fprintf(stderr,"queue size=%d\t\r",smv);
    }
    fprintf(stderr,"waiting for thread\r");
    /*   - ,       (   :)
             
    */
    sem_post(&buff_count);
    pthread_join(tid,NULL);//ģ  
    //
    pthread_mutex_destroy(&buff_mutex);
    sem_destroy(&buff_count);
    pthread_mutex_destroy(&reader_mutex);
    pthread_cond_destroy(&reader_cv);
    return 0;
}
